package net.sys42.dakedres.grafting.block.entity;

import eu.pb4.sgui.api.gui.SimpleGui;
import net.minecraft.inventory.Inventory;
import net.minecraft.screen.GenericContainerScreenHandler;
import net.minecraft.screen.ScreenHandlerType;
import net.minecraft.screen.slot.Slot;

public class AttachedInventory {
	private Inventory inventory;
	public AttachedInventory(Inventory inventory) {
		this.inventory = inventory;
	}

	public static boolean valid(Inventory inventory) {
		return inventory.size() >= 9 && (inventory.size() % 9) == 0;
	}

	public int rows() {
		return Math.min(inventory.size() / 9, 2);
	}

	public ScreenHandlerType<GenericContainerScreenHandler> extendedScreenHandlerType(int basis) {
		int r = rows() + basis;

		if(r <= 2) {
			return ScreenHandlerType.GENERIC_9X3;
		} else if(r == 3) {
			return ScreenHandlerType.GENERIC_9X4;
		} else if(r == 4) {
			return ScreenHandlerType.GENERIC_9X5;
		} else {
			return ScreenHandlerType.GENERIC_9X6;
		}
	}

	public void redirectSlots(int basis, SimpleGui gui) {
		int sizeBefore = (basis + 1) * 9;
		for(int i = 0; i < rows() * 9; i++) {
			gui.setSlotRedirect(sizeBefore + i, new Slot(inventory, i, i, 0));
		}
	}
}
